#*************************************************************************************************************
# Programm PYGLEIT
# 29.11.2021 Rieg
#*************************************************************************************************************
ti= False      # True fuer TI-Nspire, False fuer PC

if ti == True:
  from ti_system import clear_history
from math import *

#**********************************************************************
#  Function sofunc
#**********************************************************************
def sofunc():
  global eps,bd,alfa1,alfa2,soit

  epsh2= eps*eps
  soit=  bd*bd*eps/(2*(1-epsh2)*(1-epsh2))*sqrt(pi*pi*(1-epsh2)+16*epsh2)* \
         alfa1*(eps-1)/(alfa2+eps)


#*************************************************************************************************************
# Function choice
#*************************************************************************************************************
def choice():
  global ikey
  
  if ti == True:
    clear_history()
  
  while True:
    print()
    print("Gleitlagerber. DIN 31652, 9 Info")
    print("0 eps iterativ/direkt")
    print("1 Kraft,Drehzahl")
    print("2 Durchm./Breite/h0lim")
    print("3 Lagerspiel/dyn.Visko.")
    print("4 Oeldruck/Zufuehrung")
    print("5 Temp./Ausd.koef.")
    print("6 momentan def. Werte")
    print("7 Compute")
    print("8 Exit")
    key= input("Ihre Wahl: ")
    if key in ("0","1","2","3","4","5","6","7","8","9"):
      break
    
  ikey= int(key)
  key= " "

#*************************************************************************************************************
# Hauptprogramm
#*************************************************************************************************************
choice()

#----------------------------------------------------------------------
#  Startwerte
#----------------------------------------------------------------------
f=36000. 
rn=2000. 
d=120.
b=60.
s=0.12
eta=27.
pe=5.
dh=5.
a1b=0.000023
a1s=0.000011
tein=58.
taus=78.
h0lim= 0.005
ifall=1
kflag=0

temp= 0.5*(tein+taus)

#----------------------------------------------------------------------
#Endlos-Schleife
#----------------------------------------------------------------------
while True:

#----------------------------------------------------------------------
# i Info
#----------------------------------------------------------------------
  if ikey == 9:
    if ti == True:
      clear_history()
    print()
    print("PYGLEIT MK1,Lehrstuhl Konstruktionslehre+CAD,Universitaet Bayreuth,")
    print("Prof.Frank Rieg,29.11.2021,Gleitlagerberechnung DIN 31652.")
    print("Genaueres siehe Buch 'Decker:Maschinenelemente',20.Auflage.")
    key=input("weiter mit Enter-Taste")
    choice()
  
#----------------------------------------------------------------------
#  F1 Kraft, Drehzahl
#----------------------------------------------------------------------
  if ikey == 1:
    if ti == True:
      clear_history()
    print()
    print("Kraft, Drehzahl:")

    f=  float(input("Kraft (N)= ? "))
    rn= float(input("Drehzahl (1/min)= ? "))

    key=input("weiter mit Enter-Taste")
    choice()

#----------------------------------------------------------------------
#  F2 Durchmesser und Breite und h0lim
#----------------------------------------------------------------------
  if ikey == 2:
    if ti == True:
      clear_history()
    print()
    print("Durchmesser,Breite,h0lim:")

    d=     float(input("Durchmesser (mm)? "))
    b=     float(input("Breite (mm)? "))
    h0lim= float(input("h0lim (mm)? "))
  
    key=input("weiter mit Enter-Taste")
    choice()

#----------------------------------------------------------------------
#  F3 Lagerspiel/dyn.Visko.
#----------------------------------------------------------------------
  if ikey == 3:
    if ti == True:
      clear_history()
    print()
    print("Lagerspiel/dyn.Viskositaet:")

    s=   float(input("Lagerspiel (mm)? "))
    eta= float(input("dyn.Vis.(mPa*s)? "))

    key=input("weiter mit Enter-Taste")
    choice()

#----------------------------------------------------------------------
#  F4  Oeldruck und Zufuehrung
#----------------------------------------------------------------------
  if ikey == 4:
    if ti == True:
      clear_history()
    print()
    print("Oeldruck und Zufuehrung:")

    pe= float(input("Oeldruck (bar)? "))

    while True:
      print("Oelzufuehrung:")
      print("  1:S-Loch entgegen Last")
      print("  2:S-Loch 90 Grad zur Last")
      print("  3:Ringnut")
      jey= input("  Ihre Wahl: ")
      if jey in ("1","2","3"):
        break
    ifall= int(jey)

    dh= float(input("dH bzw. bG (mm)? "))

    key=input("weiter mit Enter-Taste")
    choice()

#----------------------------------------------------------------------
#  F5 Temperatur,Ausdehnungszahlen
#----------------------------------------------------------------------
  if ikey == 5:
    if ti == True:
      clear_history()
    print()
    print("Temperatur,Ausdehnungszahlen:")

    tein= float(input("OelEinT (Grad C)? "))
    taus= float(input("OelAusT (Grad C)? "))
    print("alpha Welle= {0:f} 1/K".format(a1s))
    print("alpha Lager= {0:f} 1/K".format(a1b))
    
    while True:
      jey= input("alpha aendern?0=nein,1=ja:")
      if jey in ("0","1"):
        break
    ica= int(jey)

    if ica == 1:
      a1s = float(input("alpha Welle (1/K)? "))
      a1b = float(input("alpha Lager (1/K)? "))

    temp= 0.5*(tein+taus)

    key=input("weiter mit Enter-Taste")
    choice()
    
#----------------------------------------------------------------------
#  F6 Anzeige der Eingabewerte
#----------------------------------------------------------------------
  if ikey == 6:
    if ti == True:
      clear_history()
    print()
    print("momentan def. Werte 1:")
   
    print("Kraft= {0:.2f} N".format(f))
    print("Drehzahl= {0:.2f} 1/min".format(rn)) 
    print("Durchm.= {0:.2f} mm".format(d))
    print("Breite= {0:.2f} mm".format(b)) 
    print("Lagerspiel= {0:.4f} mm".format(s)) 
    print("dyn.Visko.= {0:.2f} mPa*s".format(eta)) 
    print("Oeldruck= {0:.1f} bar".format(pe))
    print("Oelzufu.Fall= {0:d}".format(ifall))
    print("Oelboh.= {0:.1f} mm".format(dh))
    
    key=input("weiter mit Enter-Taste")
    if ti == True:
      clear_history()
    print()
    print("momentan def. Werte 2:")
  
    print("OelEinT= {0:.1f} Grad C".format(tein))
    print("OelAusT= {0:.1f} Grad C".format(taus))
    print("S-FilmT= {0:.1f} Grad C".format(temp))
    print("al.Welle= {0:f} 1/K".format(a1s))
    print("al.Lager= {0:f} 1/K".format(a1b))
    print("h0lim= {0:.5f} mm".format(h0lim))
    
    key=input("weiter mit Enter-Taste")
    choice()

#----------------------------------------------------------------------
#  0 iterativ oder direkt?
#----------------------------------------------------------------------
  if ikey == 0:
    if ti == True:
      clear_history()
    print()

    while True:
      print()
      jey= input("eps iterativ=0/direkt=1:")
      if jey in ("0","1"):
        break
    kflag= int(jey)

    key=input("weiter mit Enter-Taste")
    choice()

#----------------------------------------------------------------------
#  F7 Ergebnisse
#----------------------------------------------------------------------
  if ikey == 7:
    if ti == True:
      clear_history()

#======================================================================
#  U,Omega,psi,B/D,P quer und Sommerfeld-Zahl und andrucken
#======================================================================
    u   = d*pi*rn/60000.
    ome = 2*pi*rn/60.
    psim= s/d
    dpsi= (a1b-a1s)*(temp-20.)
    psi = psim+dpsi
    bd  = b/d
    pq  = f/(b*d)

    so  = pq*psi*psi*1e9/(eta*ome)

    print()
    print("Ergebnisse 1:")
  
    print("B/D= {0:.2f} mm".format(bd))
    print("u= {0:.1f} m/s".format(u)) 
    print("p= {0:.2f} N/mm2".format(pq))
    print("psi= {0:.5f}".format(psi)) 
    print("So= {0:.2f}".format(so)) 
      
#======================================================================
#  eps berechnen
#======================================================================
    if bd < 0.125 or bd > 1:
      print("B/D zu klein/gross")
      print("0.125 >= B/D <= 1")

      key=input("weiter mit Enter-Taste")
      choice()
 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#  eps berechnen ueber Intervallschachtelung
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    alfa1= 1.1642   -1.9456*bd  +7.1161*bd**2- \
           10.1073*bd**3 +5.0141*bd**4
    alfa2= -1.000026-0.023634*bd-0.4215*bd**2- \
           0.038817*bd**3-0.090551*bd**4

    xu=  0.125
    xo=  0.999
    tol= 0.0001
    n=   10000
    i=   0

    iflag= 1
    fehler= (xo-xu)/2

    while fehler > tol and i < n:
      xneu= (xo+xu)/2

      eps= xneu
      sofunc()
      fxneu= (so-soit)

      eps= xu
      sofunc()
      fxu= (so-soit)

      if fxneu*fxu < 0:
        xo= xneu
      else:
        xu= xneu
      fehler*= 0.5
      i+=1

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#  eps berechnen ueber direkte Formeln: Iteration hat versagt
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if i >= n  or kflag == 1:

      if 0.125 <= bd and bd <= 0.167:
        ex=  0.0614368*(log10(so)**3)+0.0459025*(log10(so)**2)+ \
             0.0761622*log10(so)-0.0350305

      elif 0.167 < bd and bd <= 0.2:
        ex=  0.0609246*(log10(so)**3)-0.0009578*(log10(so)**2)+ \
             0.0644066*log10(so)-0.0502757

      elif 0.200 < bd and bd <= 0.25:
        ex=  0.0624507*(log10(so)**3)-0.0251849*(log10(so)**2)+ \
             0.0715752*log10(so)-0.0594245

      elif 0.250 < bd and bd <= 0.33:
        ex=  0.0608744*(log10(so)**3)-0.0657667*(log10(so)**2)+ \
             0.0868669*log10(so)-0.0710114

      elif 0.330 < bd and bd <= 0.40:
        ex=  0.0592091*(log10(so)**3)-0.114519 *(log10(so)**2)+ \
             0.129530 *log10(so)-0.0912981

      elif 0.400 < bd and bd <= 0.50:
        ex=  0.0583217*(log10(so)**3)-0.145226 *(log10(so)**2)+ \
             0.168221 *log10(so)-0.108936

      elif 0.500 < bd and bd <= 0.75:
        ex=  0.0545729*(log10(so)**3)-0.183951 *(log10(so)**2)+ \
             0.228868 *log10(so)-0.136875

      else:
        ex=  0.0191334*(log10(so)**3)-0.288190 *(log10(so)**2)+ \
             0.501590 *log10(so)-0.281377

      eps= 10**ex
      iflag= 0
      i= 0

#======================================================================
#  minimale Schmierspalthoehe h0 berechnen
#======================================================================
    h0= 0.5*d*psi*(1.-eps)

#======================================================================
#  Verlagerungswinkel Beta berechnen
#======================================================================
    beta= ((eps**4)*(6.6294   - 1.591732*bd) + \
           (eps**3)*(-13.3415 + 3.424337*bd) + \
           (eps**2)*(8.73393  - 2.3291  *bd) + \
            eps    *(-2.5905  + 0.798745*bd) + \
                    (1.152624 - 0.105465*bd))* \
           atan(pi*sqrt(1-eps*eps)/(2*eps))

    beta*= 180/pi  

    print("eps({0:d})= {1:.3f}".format(i,eps))
    print("beta= {0:.2f} Grad".format(beta)) 
    print("h0= {0:.5f} mm".format(h0))
    print("h0lim= {0:.5f}".format(h0lim)) 
    
    key=input("weiter mit Enter-Taste")

#======================================================================
#  Reynolds-Zahl
#======================================================================
    re= pi*d*rn/60*psi*d*900/(2*eta*1000)
    rs= 41.3*sqrt(d/s)

#======================================================================
#  bezogene Reibungszahl my/psi
#======================================================================
    ac = 1.153423-2.69332*bd+6.552763*(bd**2)- \
         7.81938*(bd**3)+3.405146*(bd**4)

    ae = -0.7441784+0.104245*bd-0.343503*(bd**2)+ \
         0.4677244*(bd**3)-0.215028*(bd**4)

    af = -0.0105921+0.342048*bd-0.459955*(bd**2)+ \
         0.381193*(bd**3)-0.1056112*(bd**4)

    ag = -0.000397154-0.01669*bd+0.00966612*(bd**2)- \
         0.0191126*(bd**3)-0.01094135*(bd**4)

    ah = 0.00258444-0.00870384*bd-0.00157289*(bd**2)+ \
         0.01759905*(bd**3)-0.006688832*(bd**4)

    y  = ac+ae*log10(so)+af*(log10(so)**2)+ \
         ag*(log10(so)**3)+ah*(log10(so)**4) 

    brz= 10**y

#======================================================================
# Schmierstoffdurchsatz wg. Eigendruckentwicklung
#======================================================================
    q1= 0.25*(bd-0.223*(bd**3))*eps
    Q1= ((d/10)**3)*psi*ome*q1

#======================================================================
# Schmierstoffdurchsatz wg. Zufuehrdruck
#======================================================================
    dhb= dh/b

    if ifall == 1:
      qh= 1.204+0.368*dhb-1.046*(dhb**2)+1.942*(dhb**3)
      q2= pi/48*((1+eps)**3)/(log(b/dh)*qh)

    if ifall == 2:
      qh= 1.204+0.368*dhb-1.046*(dhb**2)+1.942*(dhb**3)
      q2= pi/48/(log(b/dh)*qh)

    if ifall == 3:
      q2= pi/24*(1+1.5*eps*eps)/bd*b/(b-dh)

    Q2= ((d/10)**3)*(psi**3)*pe/eta*q2*1e8

#======================================================================
# Summe Schmierstoffdurchsatz
#======================================================================
    Q= Q1+Q2

#======================================================================
# Reibleistung und Oelaustrittstemperatur
#======================================================================
    pf= brz*psi*f*u
    t2= pf/(1.8*Q)+tein

#======================================================================
# Uebergang eps und So
#======================================================================
    epsue= 1-(2*h0lim/(d*psi))
    zb=  eps
    eps= epsue
    sofunc()
    soue=  soit
    eps= zb

#======================================================================
# 2.Satz Ergebnisse andrucken
#======================================================================
    if ti == True:
      clear_history()
    print()
    print("Ergebnisse 2:")

    if re <= rs:
      print("Reynolds-Bed. erfuellt")
    else:
      print("Rey.Bed. nicht erfuellt")

    print("Re= {0:.2f}".format(re))    
    print("my/psi= {0:.4f}".format(brz)) 
    print("Po= {0:.0f} W".format(pf))
    print("Q1= {0:.1f} cm3/s".format(Q1)) 
    print("Q2= {0:.1f} cm3/s".format(Q2)) 
    print("Q = {0:.1f} cm3/s".format(Q))   
    print("OelAusT= {0:.1f} Grad C".format(t2))   
    print("eps Ue= {0:.2f}".format(epsue)) 
    print("So Ue= {0:.1f}".format(soue))   
  
    key=input("weiter mit Enter-Taste")
    choice()

#----------------------------------------------------------------------
#  F8 Exit
#----------------------------------------------------------------------
  if ikey == 8:
    print("Ende PYGLEIT")
    break
  
